/* TIN ( Totally Ignorant Nitwits). Copyright (C) 1997 Dirk Jetten */

#ifndef TIN_H 
#define TIN_H
/*
 * TIN.H
 *
 * common headerfile 
 */

/* system includes */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* global shortcut typedefs */

typedef   unsigned short u_short;
typedef   unsigned long  u_long;
typedef   unsigned int   u_int;
typedef   enum bool_t { FALSE, TRUE} bool;

/* global constants & makefile defaults. See whatsup.doc for more info */
#ifndef V0200
#define V0200 (0)
#endif

#ifndef ACT_CANNIBAL
#define ACT_CANNIBAL (0)
#endif

#ifndef DEBUG
#define DEBUG (0)
#endif

#ifndef ONEROOT
#define ONEROOT (1)
#endif

#ifndef KILLMALL
#define KILLMALL (0)
#endif

#ifndef MAXINT
#define MAXINT ((int)0x7FFF)
#endif

#ifndef MAXENVX
#define MAXENVX ((int)100)
#endif

#ifndef MAXENVY
#define MAXENVY ((int)100)
#endif

#ifndef MAXFOETUS
#define MAXFOETUS ((int)275)
#endif

#ifndef MAXCHLD             /* 0 = no limit on # of children */
#define MAXCHLD ((int)100)
#endif

#ifndef MAXTIN
#define MAXTIN ((int)500)
#endif

#ifndef MAXTURNIP           /* max growing thingies */
#define MAXTURNIP ((int)500)
#endif

#ifndef TIN_LOGFILE
#define TIN_LOGFILE "getsbig.log"
#endif

#ifndef FATR_LOW
#define FATR_LOW (200)
#endif

#ifndef FATR_DIE
#define FATR_DIE (2)
#endif

/* nr of cells -1 holding scent trail */
#ifndef MAXTRAIL
#define MAXTRAIL (6)
#endif

#ifndef STROUT
#define STROUT (1)
#endif

/* indication of a free environment cell, cannot be 0 */
#define   ENV_FREE   ((short)-1)
/* indication of an environment wall, cannot be 0 */
#define   ENV_WALL   ((short)-2)


/********** global macro's ************************/

/* output to stdout if debugging is on */
#define dbgprint if (DEBUG || glob_debug) printf

/* print dump events */
#define dmpprint if (DEBUG || glob_dump) printf

/* output to stdout if string interfacing is on */
#define strprint if ((STROUT || glob_strout) && glob_output_on) printf

/********** global typedefs/structs/whatever ******/

typedef struct _pos_t_
{
     int       row;
     int       col;
} pos_t;

typedef enum _heading_t_ { nw, w, sw, s, se, e, ne, n}
           headng_t;

typedef struct _food_t_ {
     pos_t     position;
} food_t;

typedef struct _herit_t_     /* for each imp_* include 1 item in _reward_t_ */
{
     int       age_adult;
     int       age_die;
     int       eaten_enough;                           /* max fat reserve */
     int       gathered_enough;                            /* max luggage */
     int       imp_eat;                               /* impulse values : */
     int       imp_mate;
     int       imp_agression;
     int       imp_gather_food;
     int       imp_follow_scnt;
     int       imp_move;
     int       imp_relax;
     int       father_id;                         /* father identification */
     int       mother_id;                         /* mother identification */
} herit_t;

typedef struct _unborn_t_
{
     herit_t   heritage;
     bool      occupied;
} unborn_t;

#if V0200
typedef struct _reward_t_ 
{
     int       reward_food;               /* reward when +, penalty when - */
     int       reward_mate;                
     int       reward_agression;
     int       reward_gather_food;          
     int       reward_follow_scnt;          
     int       reward_move;          
} reward_t;
#endif

typedef struct _lugg_t_
{
     u_short    food;              /* currently the only thing we're carrying */
} lugg_t;

typedef enum _gender_t_ { male, female} gender_t; 

typedef enum _behav_t { nsf, mate, die, kill, eat, 
                        move, follow_scnt, gather_food,
                        reproduce } behav_t;

typedef struct _stat_t_
{
    int no_nsf; int no_mate; int no_kill; int no_eat; 
    int no_move; int no_follow_scnt; int no_gather; 
} stat_t;

typedef struct _tin_t_
{
     bool      alive;          /* flag for memory allocation optimization */
     bool      pregnant;                    /* only meaningful to females */
     u_short   countdown;            /* duration of pregnancy in # cycles */
     int       foetus;    	              /* index in foetus memory array */
     int       id;                               /* family identification */
     long      generation;
     gender_t  sex;
     headng_t  heading;
     pos_t     trail[ MAXTRAIL]; /* FIFO of previous positions, trail[ 0] */
                                    /* is current position in environment */
     u_int     age;
     u_short   children_had;
     short     fatrsv;                             /* current fat reserve */
     lugg_t    luggage;                       /* knapsack full of goodies */
     behav_t   prev_bhviour;                        /* previous behaviour */
     herit_t   heritage;                                 /* family values */
     stat_t    stats;                                  /* life statistics */
#if V0200
     reward_t learned;   
#endif
} tin_t ;

typedef struct _cell_t_                                   /* environment unit */
{
     short     food;                              /* food equivalents in cell */
     short     scnt_trail;                             /* scent concentration */
     short     scnt_tin;                                     /* left by tin # */
     short     tin_no;          /* occupying tin # or wall or free indication */
} cell_t;

/* logging level */
typedef enum log_level 
{   log_all, log_relax, log_move, log_food,
    log_mate, log_birth_death, log_none
} log_level_t;

/* function prototypes */

/* tin life : TIN_TIN.C */
int     tin_getegg( void);
behav_t tin_cycle( int);
bool    tin_bingo( int, int);

/* actions : TIN_ACT.C */
bool    act_repro( int, int);
void    act_terminate( int, char *);
bool    act_consume( int, int);
bool    act_follow( int);
bool    act_move( int, headng_t, bool, bool);
bool    act_gather( int);

/* behaviour : TIN_BHV.C */
behav_t bhv_intention( int, int *, char *);

/* logging : TIN_LOG.C */
void    log_this( log_level_t, char *);
void    log_that( char *);

/* environmental : TIN_ENV.C */
bool    env_create( );
bool    env_free( pos_t);
int     env_neighbour( int);
bool    env_near_free( pos_t, int *, int *);
bool    env_near_occupied( int, pos_t, int *, int *);
void    env_grow( int);
void    env_trail_update( );

/* miscellanious : TIN_UTL.C */
float   utl_surv_score( int);
int     utl_random( int);
float   utl_randomf( float);
int     utl_get_free_tinslot( );
void    utl_position( pos_t, headng_t , int *, int *);
tin_t * utl_tin_create( int *, int);
int     utl_mutate( int, int);
void    utl_dump_tin( int);
void    utl_dump_tinstats( int);
void    utl_dump_foetus( int);
void    utl_dump_cell( int, int);

/* statistical : TIN_STAT.C */
void    stat_col( void);
void    stat_print( void);

/* END OF TIN.H */
#endif 


