/* TIN_ACT.C : action routines */ 
/* TIN ( Totally Ignorant Nitwits). Copyright (C) 1997 Dirk Jetten */
 
#include "tin.h"                                /* common stuff */ 
#include "tin_glob.h"                           /* global decl. */ 

char        tmpstr[ 132];

/* -------------------------------------------------------------- */ 
 
bool act_repro( int i, int foet_idx)
/* reproduction routine. returns false when called by males
 * caller of routine is tin[ i]
 */
{
     tin_t       *newborn = NULL;
     unborn_t    *father = foetus[ foet_idx];
     tin_t       *mother = tin[ i];
     herit_t     *fhp    = &father->heritage;
     herit_t     *mhp    = &mother->heritage;
     log_level_t llevel  = log_birth_death;
     int         home; 
     bool        ok;
 
     ok = ( mother->sex == female);

     if (ok) {
          newborn = utl_tin_create( &home, 500);
          ok = (( newborn != NULL ? TRUE : FALSE));
     }

     if (ok) {

          herit_t *nhp = &newborn->heritage;

          newborn->generation = mother->generation + 1;
          newborn->fatrsv = 50;
          newborn->luggage.food = 10;
          nhp->age_adult = utl_mutate((((u_int)(mhp->age_adult +
                                        fhp->age_adult)) / 2),
                                        glob_mutate);
          if (nhp->age_adult < 1 ) nhp->age_adult = 1;
          nhp->age_die   = utl_mutate((((u_int)(mhp->age_die +
                                        fhp->age_die)) / 2),
                                        glob_mutate);
          if (nhp->age_die < 1 ) nhp->age_die = 1;
          nhp->eaten_enough = utl_mutate((((u_int)(mhp->eaten_enough +
                                           fhp->eaten_enough)) / 2),
                                           glob_mutate);
          nhp->gathered_enough = utl_mutate((((u_int)(mhp->gathered_enough +
                                           fhp->gathered_enough)) / 2),
                                           glob_mutate);
          nhp->imp_eat = utl_mutate((((u_int)(mhp->imp_eat +
                                      fhp->imp_eat)) / 2), glob_mutate);

          nhp->imp_mate = utl_mutate( (((u_int)(mhp->imp_mate +
                                        fhp->imp_mate)) / 2), glob_mutate);

          nhp->imp_agression = utl_mutate((((u_int)(mhp->imp_agression +
                                            fhp->imp_agression)) / 2),
                                          glob_mutate);
 
          nhp->imp_gather_food = utl_mutate((((u_int)(mhp->imp_gather_food +
                                              fhp->imp_gather_food)) / 2),
                                            glob_mutate);

          nhp->imp_follow_scnt = utl_mutate((((u_int)(mhp->imp_follow_scnt +
                                              fhp->imp_follow_scnt)) / 2),
                                             glob_mutate);
          nhp->imp_move = utl_mutate((((u_int)(mhp->imp_move +
                                       fhp->imp_move)) / 2),
                                      glob_mutate);
          nhp->imp_relax = utl_mutate((((u_int)(mhp->imp_relax +
                                        fhp->imp_relax)) / 2),
                                       glob_mutate);
          newborn->id    = random( MAXINT);
          nhp->mother_id = fhp->mother_id;
          nhp->father_id = fhp->father_id;
     }

     if (ok) { 
	     sprintf( glob_dmpstr,
                  "Action: tin #%d at (%d,%d) gives birth to tin #%d at (%d,%d)\n",
				  i, mother->trail[0].row, mother->trail[0].col,
                  home, newborn->trail[0].row, newborn->trail[0].col);
         strprint( "%s", glob_dmpstr);
         log_this( log_birth_death, glob_dmpstr);
     } 
     else { 
         dbgprint( "Debug: act_repro #0 failed\n");
     } 

 
     return( ok); 
} 
 
/* -------------------------------------------------------------- */ 
 
void act_terminate( int i, char *reason)
/* free resources & update environment */
{
    tin_t       *stiff = tin[ i];
    int         j;

    /* mark current environment cell as free */
    env[ stiff->trail[ 0].row][stiff->trail[ 0].col]->tin_no = ENV_FREE;

    stiff->alive = FALSE;

    if (stiff->pregnant) {
       foetus[ stiff->foetus]->occupied = FALSE;
    }

    dbgprint( "Debug: act_terminate #0 tin %d died\n", i);
 
    sprintf( glob_dmpstr, "Action: tin #%d at (%d,%d) died : %s\n",
                  i, stiff->trail[0].row, stiff->trail[0].col,
                  reason);
    strprint( "%s", glob_dmpstr);
    log_this( log_birth_death, glob_dmpstr);
    population--;
}

/* -------------------------------------------------------------- */ 
 
bool act_consume( int i, int neighbr)
{ 
    register tin_t  *tp = tin[ i];
    tin_t           *np = tin[ neighbr];
    register cell_t *ep = env[ tp->trail[ 0].row][ tp->trail[ 0].col];
    bool            ok = FALSE;

    dbgprint( "Debug: act_consume #0 tin %d\n", i);

    if ( ep == NULL){
         dbgprint("Debug: act_consume #1 internal error\n");
         strprint("Error: act_consume #1 internal error\n");
         exit(1);
    }

    if ( ep->food > 0 )  
    {   /* try to find food in current cell */ 
	    dbgprint("Debug: cell: occupied %d, food %d, scent trail %d left by tin %d\n",
                      ep->tin_no, ep->food, ep->scnt_trail, ep->scnt_tin);
        ep->food--; 
        tp->fatrsv += fateqv_lunch;
        sprintf( glob_dmpstr,
        "Action: tin #%d at (%d,%d) eats turnip worth %d from environment\n",
                  i, tp->trail[0].row, tp->trail[0].col, fateqv_lunch);
        strprint( "%s", glob_dmpstr);
        log_this( log_food, glob_dmpstr);
        ok = TRUE;
        dbgprint("Debug: act_consume #3 food in environment\n");
    } 
 
    if ((!ok) && (tp->luggage.food > 0)) 
    {   /* still no luck ? try luggage */ 
        tp->luggage.food--; 
        tp->fatrsv += fateqv_lunch;
        sprintf( glob_dmpstr,
        "Action: tin #%d at (%d,%d) eats turnip worth %d from luggage\n",
                  i, tp->trail[0].row, tp->trail[0].col, fateqv_lunch);
        strprint( "%s", glob_dmpstr);
        log_this( log_food, glob_dmpstr);
        ok = TRUE;
        dbgprint("Debug: act_consume #4 food in luggage\n"); 
    } 

#if ACT_CANNIBAL

    if (!ok)
    {   /* still no luck ? kill and rob */
        if (np == NULL) return;
        act_terminate( neighbr, "eaten by another tin\n");
        tp->fatrsv += np->fatrsv;
        tp->luggage.food += np->luggage.food;
        sprintf( glob_dmpstr,
        "Action: tin #%d at (%d,%d) eats tin worth %d\n",
                  i, tp->trail[0].row, tp->trail[0].col,
                  np->fatrsv + np->luggage.food);
        strprint( "%s", glob_dmpstr);
        log_this( log_birth_death, glob_dmpstr);
        /* nothing left */
        np->fatrsv        = 0;
        np->luggage.food  = 0;
        dbgprint("Debug: act_consume #4 fed eating neighbour\n");
    }
#endif
    return( ok);
}
 
/* -------------------------------------------------------------- */ 
 
bool act_follow( int i)
{ 
    register tin_t  *tp     = tin[ i]; 
    cell_t   *ep            = env[ tp->trail[ 0].row][ tp->trail[ 0].col];
    register short target   = ep->scnt_tin;
    int      row, col       = 0;
    headng_t look           = nw;
    bool     result         = FALSE;         /* temporary result */

    /* search surrounding environment cells to determine direction of tin to
       be followed */ 
 
    while (!result && (look <= n))
    {
        utl_position( tp->trail[ 0], look, &row, &col);
        ep = env[ row][ col];
        if (!(result = ((row > 0)         && (col > 0) &&
                        (row < env_x_max) && (col < env_y_max) &&
                        (ep->scnt_trail > 0) &&
                        (ep->scnt_tin == target) &&
                        (ep->scnt_tin != i)))) {
            look++;
        }
    }

    /* nothing yet ? then some other tin crossed it's path */
    /* move in previous direction */
    if (!result) {
        return( FALSE);
    }
    else {
        return( act_move( i, look, TRUE, TRUE));
    }
}

/* -------------------------------------------------------------- */ 
 
bool act_move( int i, headng_t where, bool follow, bool pedantic)
/* try to move in given direction. if this is not possible, choose
 * another ( only if pedantic mode not set */
{
	 pos_t     newpos;
	 register  tin_t *tp   = tin[ i];
	 cell_t    *ep;
	 bool      ok          = FALSE;
	 int       tries       = 0;
	 int       trailcnt;
	 int       lastrow;
   	 int       lastcol;
	 int       maxtries    = (pedantic ? 1 : 50);

     while ((!ok) && (tries++ < maxtries)) {
         utl_position( tp->trail[ 0], where, &newpos.row, &newpos.col);
         ok = env_free( newpos);
         if ( !ok) {
            where = utl_random( 8) - 1;
            dbgprint("Debug: (%d,%d) is not free (wall or occupied)\n",
                     newpos.row, newpos.col);
         }
     }

     if (ok) {
         tp->heading = where;

         dbgprint("Debug: act_move #1 (%d,%d) is free\n",
                     newpos.row, newpos.col);

         /* clear presence flag of current position */
         env[ tp->trail[ 0].row][ tp->trail[ 0].col]->tin_no = ENV_FREE;

         /* mark last trail cell as free in environment if it's my trail */
         lastrow = tp->trail[ MAXTRAIL-1].row;
         lastcol = tp->trail[ MAXTRAIL-1].col;
         if (( lastrow != ENV_WALL                   ) &&
             ( lastcol != ENV_WALL                   ) &&
             ( env[ lastrow][ lastcol]->scnt_tin == i )) {
             ep = env[ lastrow][ lastcol];
             ep->scnt_tin   = ENV_FREE;
             ep->scnt_trail = 0;
         }

         /* shift trail array */
         for (trailcnt = MAXTRAIL-1; trailcnt > -1; trailcnt--) {
             memcpy((void *)&tp->trail[ trailcnt],
                    (void *)&tp->trail[ trailcnt-1], sizeof( pos_t));
         }

         /* update new position in environment */
         tp->trail[ 0].row = newpos.row; 
         tp->trail[ 0].col = newpos.col; 
         ep         = env[ tp->trail[ 0].row][ tp->trail[ 0].col];
         ep->tin_no = i;

         /* leave a trace */
         ep  = env[ tp->trail[ 1].row][ tp->trail[ 1].col];
         ep->scnt_tin   = i;
         ep->scnt_trail = MAXTRAIL;
     }

     if (ok) {
        if (follow) {
            sprintf( tmpstr, "follows tin #%d",
            env[ tp->trail[ 0].row][ tp->trail[ 0].col]->scnt_tin);
        }
        else {
		     sprintf( tmpstr, "moves to (%d,%d): trail (%d,%d) (%d,%d) (%d,%d) (%d,%d) (%d,%d)",
                     tp->trail[ 0].row, tp->trail[ 0].col,
                     tp->trail[ 1].row, tp->trail[ 1].col,
                     tp->trail[ 2].row, tp->trail[ 2].col,
                     tp->trail[ 3].row, tp->trail[ 3].col,
                     tp->trail[ 4].row, tp->trail[ 4].col,
                     tp->trail[ 5].row, tp->trail[ 5].col);
        }
        sprintf( glob_dmpstr, "Action: tin #%d at (%d,%d) %s\n", i,
                  tp->trail[ 1].row, tp->trail[ 1].col, tmpstr);
        strprint( "%s", glob_dmpstr);
        log_this( log_move, glob_dmpstr);

	 }
	 return( ok);
} 
 

/* -------------------------------------------------------------- */ 
 
bool act_gather( int i)
/* gather food from the environment cell */
{ 
    register tin_t  *tp = tin[ i]; 
    register cell_t *ep = env[ tp->trail[ 0].row][ tp->trail[ 0].col];
    bool            ok;

    dbgprint("Debug: act_gather #0 tin %d\n", i);
    if ( ok = ( ep->food > 0))
    {
	dbgprint("Debug: act_gather #1 cell: occupied %d, food %d, scent trail %d left by tin %d\n",
                 ep->tin_no, ep->food, ep->scnt_trail, ep->scnt_tin); 
        ep->food--; 
        tp->luggage.food++; 
        sprintf( glob_dmpstr,
        "Action: tin #%d at (%d,%d) gathers food, total = %d\n",
                  i, tp->trail[ 0].row, tp->trail[ 0].col,
                  tp->luggage.food);
        strprint( "%s", glob_dmpstr);
        log_this( log_food, glob_dmpstr);
    }
    return( ok);
}
 




