/* TIN_GLOB.C : initialization of global variables */
/* TIN ( Totally Ignorant Nitwits). Copyright (C) 1997 Dirk Jetten */

#include "tin.h" 

int       env_y_max = MAXENVY-1;
int       env_x_max = MAXENVX-1;            /* 2D environment dimensions */
cell_t    *env[ MAXENVX-1][ MAXENVY-1];          /* environment pointers */

u_int     population = 0;                      /* population at any time */

u_int     tin_max   = MAXTIN-1; 		           /* maximum population */
tin_t     *tin[ MAXTIN-1];		                         /* tin pointers */
u_int     no_tins   = (MAXTIN-1) / 10;             /* default population */
u_int     foetus_max = MAXFOETUS-1; 		       /* maximum population */
unborn_t  *foetus[ MAXFOETUS-1];

food_t    *turnip[ MAXTURNIP-1];               /* food location pointers */
int       turnip_max = MAXTURNIP-1; /* max food equivalents per supplier */
int       no_turnips = 3;                    /* starting food population */

int       fateqv_cycle = 1;                /* fat equiv. burnt per cycle */
int       fateqv_move  = 2;              /* fat equiv. burnt when moving */
int       fateqv_repro = 15;             /* fat equiv. burnt reproducing */
int       fateqv_mate  = 10;             /* fat equiv. burnt when mating */
int       fateqv_lunch = 50;            /* fat equiv. gained when eating */

int       glob_female_adv = 1.00;    /* female strength factor in fights */
float     glob_chance_pregnancy = 80.0;                             /* % */
int       glob_time_pregnancy = 500;                         /* # cycles */

float     glob_mutate = 1.5;        /* max child mutation % of heritance */

log_level_t glob_log_level = log_none;

bool      glob_debug  = FALSE;
bool      glob_dump   = TRUE;
bool      glob_strout = TRUE;
bool      glob_output_on = TRUE;

char      glob_dmpstr[ 132];                /* for behaviour watchpoints */

char      *actions[] = {
                "doing nothing",
                "mating",
                "dying",
                "killing",
                "eating",
                "moving",
                "tracing",
                "gathering food",
                "giving birth" };

char      *direction[] = {
                "north-west",
                "west",
                "south-west",
                "south",
                "south-east",
                "east",
                "north-east",
                "north" };

char      *gender[] = {
                "male",
                "female"};

char      *loglevels[] = {
                "everything",
                "only relaxing",
                "only moving",
                "food related events",
                "only mating",
                "pregnancy, birth and death related events",
                "nothing"};

/* eof TIN_GLOB.C */
