/* TIN_LOG.C : logging functions */
/* TIN ( Totally Ignorant Nitwits). Copyright (C) 1997 Dirk Jetten */

#include "tin.h"
#include "tin_glob.h"                            /* global decl. */

static FILE    *logfile;
static bool    logfile_open = FALSE;    

static bool open_logfile( void)
{
    if ((logfile = fopen( TIN_LOGFILE, "a")) == NULL){
        perror("Error: opening logfile failed");
        exit( 1);
    }
    else {
        logfile_open = TRUE;
        return (TRUE);
    }  
}

void log_this( log_level_t level, char *txt)
{
     if ((( level != glob_log_level   )   ||
          ( glob_log_level == log_none))  &&
         ( glob_log_level != log_all   )) {
          return;
     } 

     if (!logfile_open) {
          if (open_logfile()) {
                log_this( level, "Logfile opened\n");
                log_this( level, txt);
          }
     }
     else {
          fprintf( logfile, "%s", txt);
          dbgprint( "Debug: log_this #0 %s\n", txt);
     }
     return;
}

void log_that( char *txt)
{
     log_this( log_all, txt);
     return;
}

/* end of TIN_LOG.C */





