/*
 * TIN_STAT.C
 * 
 * statistic module
 */
/* TIN ( Totally Ignorant Nitwits). Copyright (C) 1997 Dirk Jetten */

#include "tin.h"
#include "tin_glob.h"

static long stat_tot_died = 0;
static int  males   = 0;
static int  females = 0;
static float avg_age         ;
static float avg_fatrsv      ;
static float avg_kids        ;
static long stat_sum_age    = 0;
static long stat_sum_tins   = 0;
static long stat_sum_fatrsv = 0;
static long stat_sum_kids   = 0;


/* -------------------------------------------------------------- */
void stat_col( void) 
/* gather relevant info from the tin, food and environment globals 
 * this routine is called very cycle 
 */
{
     tin_t *tp;

/*     if ( population == 0) return; */

     for ( tp= tin[0]; (tp != NULL) && (tp->alive); tp++) {

             stat_sum_age    += tp->age;
             stat_sum_tins++;
             stat_sum_fatrsv += tp->fatrsv;
             stat_sum_kids   += tp->children_had;
             if (tp->sex == male) {
                  males++;
             }
             else {
                  females++;
             }

     }
     avg_age    = stat_sum_age    / stat_sum_tins;
     avg_fatrsv = stat_sum_fatrsv / stat_sum_tins;
     avg_kids   = stat_sum_kids   / stat_sum_tins;
}

/* -------------------------------------------------------------- */
void stat_print( void)
/* gather relevant info from the tin, food and environment globals
 * this routine is called very cycle
 */
{
     printf( "STAT: total tins alive c=%d g=%d\n", stat_sum_tins, population);
     printf( "STAT:    male            = %d\n", males);
     printf( "STAT:    female          = %d\n", females);
     printf( "STAT: average age        = %d\n", avg_age);
     printf( "STAT: average # children = %d\n", avg_kids);
     printf( "STAT: average fatreserve = %d\n", avg_fatrsv);
}
