/* TIN_TIN.C */
/* TIN ( Totally Ignorant Nitwits). Copyright (C) 1997 Dirk Jetten */
 
#include "tin.h"                                /* common stuff */ 
#include "tin_glob.h"                           /* global decl. */ 

/* -------------------------------------------------------------- */
bool tin_bingo( int mother, int father) {
/* allocate a foetus structure and copy father values */

     register tin_t    *tp = tin[ mother];
     register unborn_t *fp, *check;
     int               neighbr;

     /* collect father's heritage */
     if ((tp->foetus = tin_getegg()) != -1) {

        fp = foetus[ tp->foetus];

        /* the very beginning */
        if((check = memcpy(( void *)&fp->heritage,
                           ( void *)&tin[ father]->heritage,
                             sizeof( herit_t)               )) == fp) {
            fp->heritage.father_id = tin[ father]->id;
            fp->heritage.mother_id = tp->id;
            tp->pregnant  = TRUE;
            tp->countdown = glob_time_pregnancy;

            return( TRUE);
        }
        else {
            perror( "Error: foetus memcpy");
            exit( 1);
        }
     }
     else {
        return( FALSE);
     }
}

/* -------------------------------------------------------------- */
int tin_getegg( void) {
/* tries to allocate an entry in the global foetus array,
 * returns -1 if full
 */
     int       tmp = -1;
     int       i   = -1;

     while ((++i < foetus_max) &&
            (tmp == -1)) {
         if (foetus[ i] == NULL) {
             foetus[ i] = (unborn_t *) malloc( sizeof( unborn_t));
             if (foetus[ i] != NULL) {
                tmp = i;
                foetus[ i]->occupied = TRUE;
             }
             else {
               perror("Error: allocating foetus memory");
               exit( 1);
             }
         }
         else {
             if (!foetus[ i]->occupied) {
                 tmp = i;
                 foetus[ i]->occupied = TRUE;
             }
         }
     }
     dbgprint("Debug: tin_getegg #0 result = %d\n", tmp);
     return( tmp);
}

behav_t tin_cycle( int i)
/* A moment in the life of a tin */
{
     register tin_t *tp = tin[ i];      
     int      neighbr;
     int      ifemale, imale;
     behav_t  behaviour;
     char     tmpstr[ 30] = "out of habit";
     char     rip_info[ 100];

     tp->fatrsv -= fateqv_cycle;
     tp->age++;

     if ((tp->sex == female) &&
          tp->pregnant &&
         (--tp->countdown == 0))  { /* end of pregnancy period */
        tp->pregnant = FALSE;
        if ( act_repro( i, tp->foetus )) {
           tp->fatrsv -= fateqv_repro;
           tp->children_had++;
           population++;
           behaviour = reproduce;
        }
        else {
           sprintf( tmpstr, "%s", "reproduction failed");
           behaviour = nsf;
        }
        foetus[ tp->foetus]->occupied = FALSE;
     }
     else {
          behaviour = bhv_intention( i, &neighbr, rip_info);
          switch (behaviour) {
            case mate   : tp->fatrsv            -= fateqv_mate;
                          tin[ neighbr]->fatrsv -= fateqv_mate;

                          if( tp->sex == female) {
                              ifemale = i;
                              imale   = neighbr;
                          }
                          else {
                              ifemale = neighbr;
                              imale   = i;
                          }
          		          dbgprint("Debug: tin_cycle #0 mating, female = %d, male = %d\n", ifemale, imale);
                          if ((tin[ ifemale]->sex == female) &&
                              (!tin[ ifemale]->pregnant)     &&
                              ((utl_randomf( 101.0) - 1.0) <
                               glob_chance_pregnancy)) {
     				          dbgprint( "Debug: tin_cycle #1 about to get pregnant\n");
                              if (tin_bingo( ifemale, imale)) {
                                 sprintf( tmpstr, "*bingo*, foetus %d",
                                               tin[ ifemale]->foetus);
                              }
                              else {
                                 sprintf( tmpstr, " %d did not get pregnant",
                                          ifemale);
                              }
                          }
                          sprintf( glob_dmpstr,
			                       "Action: tin #%d at (%d,%d) mating with tin #%d, %s\n",
                                   i, tp->trail[0].row, tp->trail[0].col,
                                   neighbr, tmpstr);
                          tp->stats.no_mate++;
                          strprint( "%s", glob_dmpstr);
                          log_this( log_mate, glob_dmpstr);
                          break;
            case follow_scnt :
                          if (act_follow( i)) {
                             tp->fatrsv -= fateqv_move;
                             tp->stats.no_follow_scnt++;
                          }
                          else {
                             behaviour = nsf;
                             sprintf( tmpstr, "%s", "tracing failed");
                          }
                          break;
            case die    : act_terminate( i, rip_info);
                          break;
            case kill   : act_terminate( neighbr, rip_info);
                          tp->stats.no_kill++;
                          break;
            case eat    : if (act_consume( i, neighbr)) {
                             tp->stats.no_eat++;
                          }
                          else {
                             sprintf( tmpstr, "%s", "eating failed");
                             behaviour = nsf;
                          }
                          break;
            case move   : if (act_move( i, tp->heading, FALSE, FALSE)){
                             tp->stats.no_move++;
                             tp->fatrsv -= fateqv_move;
                          }
                          else {
                             sprintf( tmpstr, "%s", "moving failed");
                             behaviour = nsf;
                          }
                          break;
            case gather_food :
                          if (act_gather( i)) {
                             tp->stats.no_gather++;
                          }
                          else {
                             sprintf( tmpstr, "%s", "gathering failed");
                             behaviour = nsf;
                          }
                          break;
          }
     }
     if ( behaviour == nsf) {
         sprintf(glob_dmpstr, "Action: tin #%d at (%d,%d) %s, %s\n", i,
                         tp->trail[ 0].row,
                         tp->trail[ 0].col, actions[ behaviour], tmpstr);
         strprint("%s", glob_dmpstr);
         log_this( log_relax, glob_dmpstr);
         tp->stats.no_nsf++;
     }

     dbgprint( "Debug: tin_cycle #1 %s\n", actions[ behaviour]);
     tp->prev_bhviour = behaviour;
     return( behaviour);
}

